package com.companyname.s3;

import org.junit.Test;
import software.amazon.awssdk.core.sync.RequestBody;
import software.amazon.awssdk.http.apache.ApacheHttpClient;
import software.amazon.awssdk.regions.Region;
import software.amazon.awssdk.services.s3.S3Client;
import software.amazon.awssdk.services.s3.model.PutObjectRequest;

import java.nio.ByteBuffer;
import java.time.Duration;
import java.util.concurrent.ExecutionException;

public class S3Test {

    private final String value = "test-stub-value";

    @Test
    public void readWriteTest() throws ExecutionException, InterruptedException {
        S3Client s3 = S3Client.builder().httpClient(ApacheHttpClient.builder()
                .connectionTimeout(Duration.ofSeconds(5))
                .socketTimeout(Duration.ofSeconds(15))
                .build()).region(Region.US_EAST_1).build();

        String bucket = "test-bucket";
        String key = "key";

        s3.putObject(PutObjectRequest.builder().bucket(bucket).key(key).build(),
                RequestBody.fromByteBuffer(ByteBuffer.wrap(value.getBytes())));
    }
}
